
.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm
.586

;SzCopy_dw	PROTO :DWORD,:DWORD

LOOP_COUNT		= 1000000
ShowExamples	= 1	; 1 to show the text examples, 0 for timings only
ShowSizes	= 1	; activate ShowCodeSize
UseOldCat	= 1	; 1 to show timings for old cat$ macro
ShowUsage	= 1	; explain use of CAT$ macro
ShowLamps	= 1	; show Lean_And_Mean_Points

mcDefBufLen	= 1024	; len of default buffer
mcStringSlots	= 10	; max number of arguments for CAT$

mcBinSlots	= 10	; for later use with multiple
mcHexSlots	= 10	; BIN$ or HEX$ args
UseCatB	= 0

CAT$ MACRO dest:REQ, src:VARARG
LOCAL SrcCt, isaddr, ia
	push edi
	mov edi, offset mcStrBuffer	;; will hold pointer to received strings
	SrcCt = 0
	FOR arg, <src>
		LOCAL nustr, quot, tmp$
		SrcCt = SrcCt + 1
		if SrcCt gt mcStringSlots
			echo TOO MANY STRINGS in CAT$:
			tmp$ CATSTR <max allowed: >, %mcStringSlots
			% echo tmp$
			tmp$ CATSTR <dest>,<, >,<src>
			% echo tmp$
			tmp$ CATSTR <Last valid stringarg: >, <arg>
			% echo tmp$
			echo
			crashit
			EXITM <0>
		endif
		isaddr SUBSTR <arg>, 1, 4
		ia INSTR <ADDR Addr addr>, isaddr
		if ia
			tmp$  SUBSTR <arg>, 6
			tmp$  CATSTR <lea eax, >, tmp$
			tmp$  ;; insert lea eax, whatever
;			% echo tmp$
		else
			quot SUBSTR <arg>, 1, 1
			tmp$ equ <arg>
			ifidn quot, <">				;; if 1st char = "
				.data
				nustr db arg, 0			;; write arg to .data section
				.code
				tmp$ equ <offset nustr>
			endif
			ifdif tmp$, <eax>
				mov eax, tmp$			;; avoid a mov eax, eax
			endif
		endif
		stosd		;; move next string address into mcStrBuffer
          ENDM
	ia = @SizeStr(<dest>)
;	tmp$ CATSTR <SizeIs >, %ia, < bytes>
;	% echo <dest>
;	% echo tmp$
	if ia lt 5
;		echo ialess5
		ia = 0
	else
		isaddr SUBSTR <dest>, 1, 4
		ia INSTR <ADDR Addr addr>, isaddr
;		echo ianotnull
	endif
	if ia
		tmp$  SUBSTR <dest>, 6
		tmp$  CATSTR <lea edx, >, tmp$
		tmp$  ;; insert lea edx, whatever
	else
		mov edx, dest	;; edx=0: use mcDefBuffer, edx=1: continue with mcLastPos$
	endif
	if UseCatB
		UseCatB = 0
		call MulCatCopyB
	else
		call MulCatCopyA
	endif
	pop edi
	EXITM <eax>
ENDM

MinLampSize = 200
LAMP$ MACRO cycles:REQ, csize:REQ	; Usage: print LAMP$(cycles, size), " LAMPs", 13, 10
	ffree ST(7)			;; free the stack for pushing
	mov eax, csize
	.if eax==0
		add eax, MinLampSize
	.endif
	push eax
	fild dword ptr [esp]		;; move into ST (0)
	pop eax
	fsqrt
	push cycles
	fild dword ptr [esp]		;; push cycles on FPU
	fmul ST, ST(1)		;; multiply with sqrt(size)
	fistp dword ptr [esp]
	pop eax
	invoke dwtoa, eax, addr LampsBuffer
EXITM <offset LampsBuffer>
ENDM

.data?
LampsBuffer	dd 80 dup (?)
mcStrCounter	dd ?	; number of src arguments
mcBinCounter	dd ?	; number of BIN$s
mcHexCounter	dd ?	; number of HEX$s
mcLastPos$	dd ?	; pointer to last position for append, use with CAT$(1, ...)
mcStrBuffer	dd mcStringSlots dup (?)	; holds pointers to CAT$ args
mcBinBuffer	dd mcBinSlots*36/4 dup (?)	; holds contents of BIN$s
mcHexBuffer	dd mcHexSlots*10/4 dup (?)	; holds contents of HEX$s
mcDefBuffer	dd mcDefBufLen/4 dup (?)	; default buffer if first arg=0

; based on code by MichaelW, http://www.masm32.com/board/index.php?topic=1589.30
; http://www.masm32.com/board/index.php?topic=1589.msg12174#msg12174
; JimG May 10, 2005, 05:25:55

.code
CrLf$	dd CrLf_txt
Usage$	dd UsageTxt
CrLf_txt	db 13, 10, 0, 0
; 

UsageTxt	db 13,10, " ----------------------- CAT$ usage: -----------------------", 13, 10
	db 13, 10, "1. Like old cat$ (but no zero-ing of MyBuffer needed):", 13, 10
	db 9, "mov eax, CAT$(addr MyBuffer, ",34,"Test",34,", addr Src2)", 13, 10
	db 13, 10, "2. Write strings to a default buffer:", 13, 10
				db 9, "invoke MessageBox, 0, CAT$(0, ",34,"Ciao ",34,", addr YourName),",13,10,9,"chr$(",34,"Title",34,"), MB_OK", 13, 10
	db 13,10,9,"mov eax, CAT$(0, ",34,"Test1: ",34,", addr Src2, str$(eax), ",34,"bytes",34,")", 13, 10
	db 13, 10, "3. Append to last position after a CAT$(0) or CAT$(addr MyBuffer):", 13, 10
	db 9, "mov eax, CAT$(1, ",34,"Test3",34,", addr Src4)", 13, 10, 10
				db " ----------------------- CAT$ timings: --------------------- ", 13, 10, 10, 0

strHA	db " with th new CAT$ macro"
	db 13, 10, "A cute little routine allowing you to concatenate", 13, 10, "multiple strings of different origins",0
strN	db " with the new CAT$ macro"
	db 13, 10, "A cute little routine allowing you to concatenate", 13, 10, "multiple strings of different origins",0
strO	db " with the OLD cat$ macro"
	db 13, 10, "A cute little routine allowing you to concatenate", 13, 10, "multiple strings of different origins",0

start:
	if ShowSizes
		call ShowCodeSize
	endif
	if ShowExamples
		print CAT$(0, "Ciao bello, ", "this is test A", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$
		UseCatB = 1
		print CAT$(0, "Ciao bello, ", "this is test B", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$

		UseCatB = 1
		print CAT$(0, "Ciao bello, ", "this is test B", addr strHA, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$

		if UseOldCat
			print cat$(addr mcDefBuffer, "Ciao bello, ", "this is test X", addr strO, CrLf$, "Fantastic ", str$(99), " bytes short!", CrLf$, CrLf$)
		else
			print CAT$(addr mcDefBuffer, "Ciao bello, ", "this is test B", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
		endif
	endif
	if ShowUsage
		print Usage$
	endif
	invoke Sleep, 250
	push ebx

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	mov eax, CAT$(0, CrLf$, "Ciao bello, ", "this is test A", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	; same: mov eax, CAT$(addr mcDefBuffer, CrLf$, "Ciao bello, ", "this is test A", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
    counter_end
	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks CAT$a ",9)
	mov eax, offset pend2a
	sub eax, offset MulCatCopyA
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	if ShowLamps
		print LAMP$(ebx, eax)
		print chr$(" LAMPs", 13, 10)
	else
		print chr$(13, 10)
	endif

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	mov eax, CAT$(0, CrLf$, "Ciao bello, ", "this is test A", addr strHA, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	; same: mov eax, CAT$(addr mcDefBuffer, CrLf$, "Ciao bello, ", "this is test A", addr strHA, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
    counter_end
	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks CAT$aHA ",9)
	mov eax, offset pend2a
	sub eax, offset MulCatCopyA
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	if ShowLamps
		print LAMP$(ebx, eax)
		print chr$(" LAMPs", 13, 10)
	else
		print chr$(13, 10)
	endif

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	UseCatB = 1
	mov eax, CAT$(0, CrLf$, "Ciao bello, ", "this is test B", addr strN, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	; identical: mov eax, CAT$(addr mcDefBuffer, ...
    counter_end
	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks CAT$b ",9)
	mov eax, offset pend2b
	sub eax, offset MulCatCopyB
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	if ShowLamps
		print LAMP$(ebx, eax)
		print chr$(" LAMPs", 13, 10)
	else
		print chr$(13, 10)
	endif

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	UseCatB = 1
	mov eax, CAT$(0, CrLf$, "Ciao bello, ", "this is test B", addr strHA, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	; identical: mov eax, CAT$(addr mcDefBuffer, ...
    counter_end
	mov ebx, eax	; store cycle count
	print ustr$(eax)
	print chr$(" clocks CAT$bHA ",9)
	mov eax, offset pend2b
	sub eax, offset MulCatCopyB
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	if ShowLamps
		print LAMP$(ebx, eax)
		print chr$(" LAMPs", 13, 10)
	else
		print chr$(13, 10)
	endif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	if UseOldCat
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$
		mov eax, cat$(addr mcDefBuffer, CrLf$, "Ciao bello, ", "this is test X", addr strO, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	else
		mov byte ptr [mcDefBuffer], 0	; clear the target buffer for cat$
		mov eax, CAT$(addr mcDefBuffer, CrLf$, "Ciao bello, ", "this is test A", addr strO, CrLf$, "Fantastic ", str$(113), " bytes short!", CrLf$, CrLf$)
	endif

	counter_end

	mov ebx, eax	; store cycle count
	print ustr$(eax)
	if UseOldCat
		print chr$(" clocks old cat$ ",9)
		mov eax, 99	; calculated with ShowCodeSize and UseOldCat = 0
	else
		print chr$(" clocks CAT$a ",9)
		mov eax, offset pend2a
		sub eax, offset MulCatCopyA
	endif
	push eax
	print str$(eax)
	print chr$(" bytes ", 9)
	pop eax
	if ShowLamps
		print LAMP$(ebx, eax)
		print chr$(" LAMPs", 13, 10)
		print chr$(13, 10), "LAMPs = Lean And Mean Points = cycles * sqrt(size)", 13,10
	else
		print chr$(13, 10)
	endif

	pop ebx

    ; invoke Sleep,250            ; reduced cycle count by ~26 ??
    ; mov   eax,input(13,10,"Press enter to exit...")
    getkey
    exit

; 
; The technique used to find the terminating null was adapted
; from the MASM32 STRLEN procedure, which was adapted from an
; algorithm written by Agner Fog.
; 
;pst1:
;SzCopy_dw proc uses ebx lpsrc:DWORD,lpdest:DWORD ; (*** not used in this test ***)
;    mov   eax,lpsrc
;    mov   edx,lpdest
;    sub   eax,4
;    sub   edx,4
;  @@:   
;    mov   ebx,[eax+4]             ; get next 4 bytes
;    add   eax,4
;    lea   ecx,[ebx-01010101h]     ; subtract 1 from each byte
;    add   edx,4
;    test  ecx,80808080h
;    jnz   @F                      ; jump if zero byte
;    mov   [edx],ebx
;    jmp   @B
;  @@:
;    mov   cl,[eax]
;    add   eax,1
;    mov   [edx],cl
;    add   edx,1
;    test  cl,cl
;    jnz   @B
;    sub   eax,lpsrc
;    sub   eax,1                    ; return length w/o null
;    ret
;SzCopy_dw endp
;pend1:

;	invoke MulCatCopy, 123, 456	; 12 bytes
;	call MulCatCopy				; 5 bytes

safe = 1

COMMENT ~
mcStrCounter	dd ?	; number of src arguments
mcBinCounter	dd ?	; number of BIN$s
mcHexCounter	dd ?	; number of HEX$s
mcLastPos$	dd ?	; last position for append, use with CAT$(1, ...)
mcStrBuffer	dd mcStringSlots dup (?)	; holds pointers to CAT$ args
mcBinBuffer	dd mcBinSlots*36/4 dup (?)	; holds contents of BIN$s
mcHexBuffer	dd mcHexSlots*10/4 dup (?)	; holds contents of HEX$s
mcDefBuffer	dd mcDefBufLen/4 dup (?)	; default buffer if first arg=0 ~

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
MulCatCopyA proc
  mcMagic = 01010101h
  push ebx	; edi saved in macro
  push esi
  xor eax, eax
  stosd			; mark end of args
  .if edx==0
	mov edx, offset mcDefBuffer	; edx=0, safe copy: take default 
	mov edi, mcDefBufLen		; buffer len, e.g. 1024, then add
	add edi, edx				; current pos and check below
  .else
	.if edx==1
		mov edx, mcLastPos$
	.endif
	mov edi, edx
	add edi, 0FFFFFFFh			; only edx==0 is safe ^ ^
  .endif
  mov esi, offset mcStrBuffer
  push edx	; will return a pointer to string start at end of proc

; ---------- put the pointer to the next string argument into eax: ----------
mcNext:
  lodsd	; mov eax, lpsrc, mov edx, lpdest
  or eax, eax
  jz mcDone

align 4	; TEST A ----------------------------------------
@@:   
  mov ebx, [eax]			; get next 4 bytes
  ; mov ecx, ebx			; 21% slower than lea on P4,
  ; sub ecx, mcMagic		; tested with rep 800
  lea ecx, [ebx-mcMagic]	; subtract 1 from each byte
  test ecx, 80808080h
  jnz @F					; jump if zero byte
  cmp edi, edx				; safe copy...
  jle mcDone
  mov [edx], ebx			; store a dword
  add eax, 4
  add edx, 4				; inc destination
  jmp @B

; align 16					; 2 bytes more but absolutely no improvement
@@:
  mov cl, [eax]				; copy non-aligned bytes
  mov [edx], cl
  add eax, 1
  add edx, 1
  test cl, cl
  jnz @B
  dec edx
  jmp mcNext

mcDone:
  mov mcLastPos$, edx	; save pointer to END of string, for use with CAT$(1, ...
  pop eax					; pushed as edx, return pointer to START of string
  pop esi
  pop ebx
  ret
MulCatCopyA endp
pend2a:

; MichaelW, http://www.masm32.com/board/index.php?topic=1589.msg12333#msg12333
; 
; The technique used to detect the terminating null, without
; detecting the first high-ascii character as a null, was
; adapted from the MASM32 STRLEN procedure, which was adapted
; from an algorithm written by Agner Fog.
; 

align 4
MulCatCopyB proc
  mcMagic = 01010101h
  push ebx	; edi saved in macro
  push esi
  xor eax, eax
  stosd			; mark end of args
  .if edx==0
	mov edx, offset mcDefBuffer	; edx=0, safe copy: take default 
	mov edi, mcDefBufLen		; buffer len, e.g. 1024, then add
	add edi, edx				; current pos and check below
  .else
	.if edx==1
		mov edx, mcLastPos$
	.endif
	mov edi, edx
	add edi, 0FFFFFFFh			; only edx==0 is safe ^ ^
  .endif
  mov esi, offset mcStrBuffer
  push edx	; will return a pointer to string start at end of proc

; ---------- put the pointer to the next string argument into eax: ----------
mcNext:
  lodsd	; mov eax, lpsrc, mov edx, lpdest
  or eax, eax
  jz mcDone

align 4	; TEST B ----------------------------------------
@@:
  mov ebx, [eax]			; get next 4 bytes
  ; mov ecx, ebx			; 21% slower than lea on P4,
  ; sub ecx, mcMagic		; tested with rep 800
  lea ecx, [ebx-mcMagic]	; subtract 1 from each byte
  test ecx, 80808080h		; same as and ecx, 80808080h
  jnz @F					; jump if zero byte

WasNotZero:
  cmp edi, edx				; safe copy...
  jle mcDone
  mov [edx], ebx			; store a dword
  add eax, 4				; eax, edx 1% faster than edx, eax on P4
  add edx, 4				; inc destination
  jmp @B

@@:	not ebx					; invert all bytes - for the full story, see
	and ecx, ebx			; http://www.masm32.com/board/index.php?topic=1589.msg12333#msg12333 
	not ebx					; and each byte with inversion, then restore bytes
	test ecx, 80808080h		; bytes=80h for null, otherwise 0
	jz WasNotZero

align 4					; align 16 is somewhat slower
@@:
  mov cl, [eax]				; copy non-aligned bytes
  mov [edx], cl
  add eax, 1				; add is 16% faster then inc on P4
  add edx, 1
  test cl, cl
  jnz @B
  dec edx
  jmp mcNext

mcDone:
  mov mcLastPos$, edx	; save pointer to END of string, for use with CAT$(1, ...
  pop eax					; pushed as edx, return pointer to START of string
  pop esi
  pop ebx
  ret
MulCatCopyB endp
pend2b:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

BeforeChkEnd:
ShowCodeSize proc uses esi

	print chr$(13, 10, "Your code section has", 9)
	mov eax, offset BeforeChkEnd - offset start
	print str$(eax)
	print chr$(" bytes ", 40, "excluding the ShowCodeSize routine", 41, 13, 10)

	print chr$("The libraries added", 9)
	mov esi, offset AfterChkEnd

	xor ecx, ecx		; counter

@@:	inc esi
	mov eax, [esi]
	inc ecx
	cmp ecx, 4000	; 7030 works, 7040 throws an exception
	ja @F
	cmp ax, 25FFh	; a long JMP
	jne @B
	mov eax, [esi+6]
	cmp ax, 25FFh	; another long JMP exactly 6 bytes later
	jne @B

@@:	print ustr$(ecx)
	print chr$(" bytes", 13, 10, 10)

;	mov esi, offset ENDCODE
;	print chr$("The linker added", 9)
;	print str$(esi)
;	print " - "
;	mov eax, offset BeforeChkEnd
;	print str$(eax)
;	print " = "
;	sub esi, offset BeforeChkEnd
;	print str$(esi)
;	print chr$(" bytes", 13, 10, 10)

	ret
ShowCodeSize endp
AfterChkEnd:

;.code _text$
;ENDCODE equ $
end start

; OPT_Linker	polink	; use Pelle's linker
; OPT_DelTmp	0	; don't delete temporary files
